'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultConfig = undefined;

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isHostAllowed = regexes => host => regexes.reduce((accumulator, currentRe) => accumulator || currentRe.test(host), false);

const commaDelimit = (config, path) => ((0, _get2.default)(config, path) || []).join(',');

const mapConfig = config => {
  const regexes = ((0, _get2.default)(config, 'allow-origin-regexes') || []).map(reString => new RegExp(reString));
  return {
    regexes,
    allowMethods: commaDelimit(config, 'allow-methods'),
    allowHeaders: commaDelimit(config, 'allow-headers'),
    exposeHeaders: commaDelimit(config, 'expose-headers'),
    maxAge: (0, _get2.default)(config, 'max-age'),
    allowCredentials: (0, _get2.default)(config, 'allow-credentials'),
    isHostAllowed: isHostAllowed(regexes)
  };
};

const defaultConfig = exports.defaultConfig = mapConfig({
  'allow-origin-regexes': ['^http.*$'],
  'allow-methods': ['GET', 'POST', 'PUT'],
  'allow-headers': ['Content-Type', 'X-Amz-Date', 'Authorization', 'X-Api-Key', 'X-Amz-Security-Token'],
  'expose-Headers': [],
  'max-age': 86400,
  'allow-credentials': true
});